Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class PositionRange

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.PositionRange

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public final class PositionRange

extends Expression

PositionRange: a boolean expression that tests whether the position() is within a certain range. This expression can occur in any context but it is optimized when it appears as a predicate (see FilterIterator)

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`PositionRange(Expression pos)` Create a position "range" for an exact position
`PositionRange(Expression min, Expression max)` Create a position range
`PositionRange(int min, int max)` Create a constant position range

Method Summary
`int` | `computeCardinality()` Determine the static cardinality
`int` | `computeSpecialProperties()` Determine the special properties of this expression
`void` | `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure
`Item` | `evaluateItem(XPathContext c)` Evaluate the expression
`int` | `getIntrinsicDependencies()` Get the dependencies
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the expression
`Expression` | `getMaxPosition()` Get the ending (max) position of the range.
`Expression` | `getMinPosition()` Get the starting (min) position of the range
`boolean` | `hasFocusDependentRange()` Test whether the range is focus-dependent.
`boolean` | `isFirstPositionOnly()` Test if the first and last position are both constant 1
`boolean` | `isMaxSameAsMin()` Test whether the max position is (by definition) the same as the min position
`Iterator` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`SequenceIterator` | `makePositionIterator(SequenceIterator base, XPathContext c)` Make an iterator over a range of a sequence determined by this position range
`TailExpression` | `makeTailExpression(Expression start)` If this is an open-ended range with a constant start position, make a TailExpression.
`boolean` | `matchesAtMostOneItem()` Test if the position range matches at most one item
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`Expression` | `simplify(StaticContext env)` Simplify an expression
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, promote, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PositionRange

    public PositionRange(Expression min,
                         Expression max)

  Create a position range

### PositionRange

    public PositionRange(Expression pos)

  Create a position "range" for an exact position

### PositionRange

    public PositionRange(int min,
                         int max)

  Create a constant position range

Method Detail

### getMinPosition

    public Expression getMinPosition()

  Get the starting (min) position of the range

### getMaxPosition

    public Expression getMaxPosition()

  Get the ending (max) position of the range. If the range is open-ended, or if the max position is by definition the same as the min, return null

### isMaxSameAsMin

    public boolean isMaxSameAsMin()

  Test whether the max position is (by definition) the same as the min position

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `Expression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### evaluateItem

    public Item evaluateItem(XPathContext c)
                      throws XPathException

  Evaluate the expression

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `c` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### makePositionIterator

    public SequenceIterator makePositionIterator(SequenceIterator base,
                                                 XPathContext c)
                                          throws XPathException

  Make an iterator over a range of a sequence determined by this position range

  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` -
  Returns:
    Type.BOOLEAN

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Get the dependencies

  Overrides:
    `getIntrinsicDependencies` in class `Expression`
  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Get the immediate sub-expressions of this expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### isFirstPositionOnly

    public boolean isFirstPositionOnly()

  Test if the first and last position are both constant 1

### hasFocusDependentRange

    public boolean hasFocusDependentRange()

  Test whether the range is focus-dependent. An example of a focus-dependent range is (1 to position()). We could treat last() specially but we don't.

### matchesAtMostOneItem

    public boolean matchesAtMostOneItem()

  Test if the position range matches at most one item

### makeTailExpression

    public TailExpression makeTailExpression(Expression start)

  If this is an open-ended range with a constant start position, make a TailExpression. Otherwise return null

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Diagnostic print of expression structure

  Specified by:
    `display` in class `Expression`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.